/**************************************************************************
                          ipmagic.c  -  The Magic of IP
                             -------------------
    begin                : Tue Jul 31 2001
    copyright            : (C) 2001 by Josiah Zayner
    email                : ajz023@motorola.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include "magic.h"


/*
   globals for our IP header, yeah, yeah  I know, but I haven't figure out how to pass
   more than one argument on a gtk_signal_connect, beside a struct and when I did that it caused seg faults

*/
GtkWidget *hl_te, *vers_te, *tos_te, *tlen_te, *id_te, *frag_te;
GtkWidget *ttl_te, *fragoff_te, *sadd_te, *dadd_te, *proto, *frag;

/* globals for udp */
GtkWidget *ulen_te, *ulen_lbl, *utype_lbl, *utype, *dnsid_lbl, *dnsid_te, *dnsop_lbl, *dnsop;
GtkWidget *dnsr_check, *aa_check, *trun_check, *recur_check, *recura_check;
GtkWidget *dnsrc_lbl, *dnsrc;
GtkWidget *src_lbl, *dst_lbl, *dst_te, *src_te, *payload;

/* globals for icmp*/
GtkWidget *itype_lbl, *icode_lbl, *itype, *isubs;


/* function to choose which protocols widgets to display */
void cast_spell(GtkWidget *oldwidg, GtkEntry *entry)
{
  char *item;
  /*
     we need these otherwise gtk_widget_hide will cause a core because
     the widgets pointing to a NULL
  */
  static int ic = 0, ud = 0;

  item = gtk_entry_get_text(entry);

  if(strstr(item, "TCP"))
  {
    if(ud){ clear_udp(); }
    if(ic){ clear_icmp(); }
    tcp_spell();
  }

  else if(strstr(item, "UDP"))
  {
    clear_tcp();
    if(ic){ clear_icmp(); }
    if(!ud){ ud = 1; }
    udp_spell();
  }

  else if(strstr(item, "ICMP"))
  {
    if(ud){ clear_udp(); }
    clear_tcp();
    if(!ic){ ic = 1; }
    icmp_spell();
  }

  else
  {
    if(ud){ clear_udp(); }
    if(ic){ clear_icmp(); }
    clear_tcp();
    gtk_widget_hide(payload);
  }
}



void ip_cauldron(void)
{
  /* widget labels for IP header */
  GtkWidget *IP_lbl, *hl_lbl, *vers_lbl, *tos_lbl, *tlen_lbl, *id_lbl, *frag_lbl;
  GtkWidget *ttl_lbl, *proto_lbl, *sadd_lbl, *dadd_lbl, *fragoff_lbl;


  GList *frags = NULL;
  GList *protos = NULL;
  char *protoc;

  /* initially assign these as NULL */
  IP_lbl = hl_lbl = vers_lbl = tos_lbl = tlen_lbl = id_lbl = frag_lbl = NULL;
  ttl_lbl = proto_lbl = sadd_lbl = dadd_lbl = ttl_te = fragoff_lbl = NULL;
  hl_te = vers_te = tos_te = tlen_te = id_te = frag_te = NULL;
  ttl_te = fragoff_te = sadd_te = dadd_te = proto = frag = NULL;

  /* display all our IP widgets */
  IP_lbl = make_label(IP_lbl, "IP Header Options", 225, 50);
  hl_lbl = make_label(hl_lbl, "Header Length(32bits x):", 30, 80);
  hl_te = make_text(hl_te, 30, 22, 175, 78);
  vers_lbl = make_label(vers_lbl, "IP Version:", 240, 80);
  vers_te = make_text(vers_te, 40, 22, 310, 78);
  tos_lbl = make_label(tos_lbl, "Type-Of-Service:", 370, 80);
  tos_te = make_text(tos_te, 40, 22, 480, 78);

  tlen_lbl = make_label(tlen_lbl, "Total Length(8bits x):", 30, 120);
  /*
  tlen_te = make_text(tlen_te, 30, 22, 175, 118);
  */
  id_lbl = make_label(id_lbl, "Packet ID:", 240, 120);
  id_te = make_text(id_te, 40, 22, 310, 118);
  ttl_lbl = make_label(ttl_lbl, "Time-To-Live:", 370, 120);
  ttl_te = make_text(ttl_te, 40, 22, 480, 118);

  /* our fragmentation combo box still haven't figured out the bit order for this */
  frag_lbl = make_label(frag_lbl, "Fragmentaion:", 185, 160);
  frag = make_combo(frag, 120, 10, 275, 160);
  frags = g_list_append(frags, (void *)"None");
  frags = g_list_append(frags, (void *)"Don't Fragment");
  frags = g_list_append(frags, (void *)"Fragment");
  frags = g_list_append(frags, (void *)"More Fragments");
  gtk_combo_set_popdown_strings(GTK_COMBO(frag), frags);
  g_list_free(frags);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(frag)->entry), FALSE);

  /*
  fragoff_lbl = make_label(fragoff_lbl, "Fragmentation Offset:", 320, 160);
  fragoff_te = make_text(fragoff_te, 40, 22, 430, 158);
  */
  /* our protocol combo box, TCP, UDP, and ICMP */
  proto_lbl = make_label(proto_lbl, "Protocol:", 220, 250);
  proto = make_combo(proto, 60, 10, 280, 250);
  protos = g_list_append(protos, (void *)"TCP");
  protos = g_list_append(protos, (void *)"UDP");
  protos = g_list_append(protos, (void *)"ICMP");
  protos = g_list_append(protos, (void *)"IP");
  gtk_combo_set_popdown_strings(GTK_COMBO(proto), protos);
  g_list_free(protos);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(proto)->entry), FALSE);

  /* if we choose a protocol clear all widgets and show the new ones */
  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(proto)->entry),
                     "changed",
                     GTK_SIGNAL_FUNC(cast_spell),
                     GTK_ENTRY(GTK_COMBO(proto)->entry)
                    );

  sadd_lbl = make_label(sadd_lbl, "Source Host:", 40, 200);
  sadd_te = make_text(sadd_te, 150, 22, 120, 200);
  dadd_lbl = make_label(dadd_lbl, "Destination Host:", 310, 200);
  dadd_te = make_text(dadd_te, 150, 22, 410, 200);
  protoc = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(proto)->entry));

  /* whatever proto is picked intialize that packet type */
  if(strstr(protoc, "TCP")){ tcp_spell();}
  else if(strstr(protoc, "UDP")){ udp_spell(); }
  else if(strstr(protoc, "ICMP")){ icmp_spell(); }
  ip_defaults((GtkWidget *)NULL);
}


void ip_defaults(GtkWidget *oldbutton)
{
  char *protoc;

  gtk_entry_set_text(GTK_ENTRY(hl_te), "5");
  gtk_entry_set_text(GTK_ENTRY(vers_te), "4");
  gtk_entry_set_text(GTK_ENTRY(tos_te), "0");
 /* gtk_entry_set_text(GTK_ENTRY(tlen_te), "40");  */
  gtk_entry_set_text(GTK_ENTRY(id_te), "0");
  gtk_entry_set_text(GTK_ENTRY(ttl_te), "64");

  /* gtk_entry_set_text(GTK_ENTRY(fragoff_te), "0"); */
  gtk_entry_set_text(GTK_ENTRY(sadd_te), "127.0.0.1");
  gtk_entry_set_text(GTK_ENTRY(dadd_te), "127.0.0.1");
  protoc = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(proto)->entry));

  if(strstr(protoc, "TCP")){ tcp_defaults();}
  else if(strstr(protoc, "UDP")){ udp_defaults(); }
  else if(strstr(protoc, "ICMP")){ icmp_defaults(); }
}

/* also add DHCP for UDP */
/* DNS widgets */
void show_utypes(GtkEntry *entry)
{
  char *uitem;
  GList *dnsops = NULL;
  GList *dnsrcs = NULL;
  static int ifdns = 0;

  uitem = gtk_entry_get_text(entry);

  if(strstr(uitem, "DNS"))
  {
    ifdns = 1;

    dnsid_lbl = make_label(dnsid_lbl, "ID:", 40, 370);
    dnsid_te = make_text(dnsid_te, 50, 22, 60, 370);

    /* ops codes */
    dnsop_lbl = make_label(dnsop_lbl, "Opcode:", 130, 370);

    dnsop = make_combo(dnsop, 120, 12, 180, 370);
    dnsops = g_list_append(dnsops, (void *)"Query");
    dnsops = g_list_append(dnsops, (void *)"Inverse Query");
    dnsops = g_list_append(dnsops, (void *)"Status");
    dnsops = g_list_append(dnsops, (void *)"Notify of SOA change");

    gtk_combo_set_popdown_strings(GTK_COMBO(dnsop), dnsops);
    g_list_free(dnsops);
    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(dnsop)->entry), FALSE);

    dnsr_check = make_check(dnsr_check, "Response Flag", 40, 400);
    aa_check = make_check(aa_check, "Authoritive Answer", 140, 400);
    trun_check = make_check(trun_check, "Truncated Message", 260, 400);
    recur_check = make_check(recur_check, "Recursion Desired", 380, 400);
    recura_check = make_check(recura_check, "Recursion Available", 40, 430);

    dnsrc_lbl = make_label(dnsrc_lbl, "Response Code:", 310, 370);

    dnsrc = make_combo(dnsrc, 120, 12, 400, 370);
    dnsrcs = g_list_append(dnsrcs, (void *)"No Error");
    dnsrcs = g_list_append(dnsrcs, (void *)"Format Error");
    dnsrcs = g_list_append(dnsrcs, (void *)"Server Failure");
    dnsrcs = g_list_append(dnsrcs, (void *)"Non Existent Domain");
    dnsrcs = g_list_append(dnsrcs, (void *)"Not Implemented");
    dnsrcs = g_list_append(dnsrcs, (void *)"Query Refused");

    gtk_combo_set_popdown_strings(GTK_COMBO(dnsrc), dnsrcs);
    g_list_free(dnsrcs);
    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(dnsrc)->entry), FALSE);

  }

    else if(strstr(uitem, "None"))
    {
      if(ifdns)
      { clear_dns(); }
    }


      else if(strstr(uitem, "DHCP"))
      {
        if(ifdns)
        { clear_dns(); }
      }

}

/* display UDP widgets */
void udp_spell(void)
{
 GList *utypes = NULL;

 src_lbl = make_label(src_lbl, "Source Port:", 40, 290);
 src_te = make_text(src_te, 50, 22, 120, 290);

 dst_lbl = make_label(dst_lbl, "Destination Port:", 190, 290);
 dst_te = make_text(dst_te, 50, 22, 290, 290);

 ulen_lbl = make_label(ulen_te, "Length:", 360, 290);
 ulen_te = make_text(ulen_te, 30, 22, 410, 290);

 utype_lbl = make_label(utype_lbl, "Packet Type:", 200, 330);
 utype = make_combo(utype, 60, 10, 290, 330);
 utypes = g_list_append(utypes, (void *)"None");
 /*
 utypes = g_list_append(utypes, (void *)"DNS");
 utypes = g_list_append(utypes, (void *)"DHCP");
 */
 gtk_combo_set_popdown_strings(GTK_COMBO(utype), utypes);
 g_list_free(utypes);
 gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(utype)->entry), FALSE);


 gtk_signal_connect(GTK_OBJECT(GTK_COMBO(utype)->entry),
                    "changed",
                    GTK_SIGNAL_FUNC(show_utypes),
                    GTK_ENTRY(GTK_COMBO(utype)->entry)
                   );


 payload = make_te(payload, 520, 80, 40, 460);
 udp_defaults();
}

/* enter in default values */
void udp_defaults(void)
{
  char usrco[6];
  char udleng[5];

  sprintf(udleng, "%d", sizeof(struct udphdr));

  /* random seed */
  srand(time(0));
  /* random source port 0-6000 */
  sprintf(usrco, "%u", 1+(unsigned int) (6000.0*rand()/(RAND_MAX+1.0)) );
  gtk_entry_set_text(GTK_ENTRY(src_te), usrco);
  gtk_entry_set_text(GTK_ENTRY(dst_te), "53");
  gtk_entry_set_text(GTK_ENTRY(ulen_te), udleng);

}


/* for clearing our UDP widgets off */
void clear_udp(void)
{

  gtk_widget_hide(src_lbl);
  gtk_widget_hide(src_te);
  gtk_widget_hide(dst_lbl);
  gtk_widget_hide(dst_te);
  gtk_widget_hide(ulen_lbl);
  gtk_widget_hide(ulen_te);
  gtk_widget_hide(utype_lbl);
  gtk_widget_hide(utype);

  /* for DNS */
  if(strstr(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(utype)->entry)), "DNS"))
  { clear_dns(); }

}

/* for clearing DNS widgets off */
void clear_dns(void)
{
  gtk_widget_hide(dnsid_lbl);
  gtk_widget_hide(dnsid_te);
  gtk_widget_hide(dnsop_lbl);
  gtk_widget_hide(dnsop);
  gtk_widget_hide(dnsr_check);
  gtk_widget_hide(aa_check);
  gtk_widget_hide(trun_check);
  gtk_widget_hide(recur_check);
  gtk_widget_hide(recura_check);
  gtk_widget_hide(dnsrc_lbl);
  gtk_widget_hide(dnsrc);

}

/* this is where the packet is actually made, we grab the values
   from the test boxes, menus, etc. and put them into the packet
*/
struct packmack *udp_gather(char *udp_pack)
{
  struct udphdr *udp_magic = clalloc(sizeof(struct udphdr));
  struct nmrhdr *nmr_magic = clalloc(sizeof(struct nmrhdr));
  struct packmack *udps = clalloc(sizeof(struct packmack));
  char data[65535 - (sizeof(struct ip) + sizeof(struct udphdr))];
  int x, d_len = 0;

  /* for DNS */
  /*
  struct HEADER *dns_magic;
  char *op;

  if(strstr(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(utype)->entry)), "DNS"))
  {
    dns_magic = (struct HEADER *)(pack + sizeof(struct ip) + sizeof(struct udphdr));
    memset(dns_magic, '\0', sizeof(struct HEADER *));
    dns_magic->id = atoi(gtk_entry_get_text(GTK_ENTRY(dnsid_te)));

    op = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(dnsop)->entry));

    if(strstr(op, "Query") && !strstr(op, "Inverse"))
    { dns_magic->opcode = QUERY; }

    else if(strstr(op, "Inverse"))
    { dns_magic->opcode = IQUERY; }

    else if(strstr(op, "Status"))
    { dns_magic->opcode = STATUS; }

    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(dnsr_check)))
    { dns_magic->qr = 1; }

    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(aa_check)))
    { dns_magic->aa = 1; }

    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(trun_check)))
    { dns_magic->tc = 1; }

    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(recur_check)))
    { dns_magic->rd = 1; }

    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(recura_check)))
    { dns_magic->ra = 1; }


  }
   */

  /* intialize data and NULL it out */
  memset(data, '\0', sizeof(data));
  /* make sure data is not  too big for one packet */
  if(sizeof(data) > gtk_text_get_length(GTK_TEXT(payload)))
  {
    for(x = 0; x < gtk_text_get_length(GTK_TEXT(payload)); x++)
    { data[x] = GTK_TEXT_INDEX(GTK_TEXT(payload),x); }
    d_len = strlen(data);
  }
  else
  { prterr("Data length to long for one packet!!\n"); }

  /* psuedo no miss routed header, create checksum packet */
  nmr_magic->saddr = wherefromto(gtk_entry_get_text(GTK_ENTRY(sadd_te)));
  nmr_magic->daddr = wherefromto(gtk_entry_get_text(GTK_ENTRY(dadd_te)));
  nmr_magic->none = 0;
  nmr_magic->protocol = 17;
  nmr_magic->length = htons(sizeof(struct udphdr) + d_len);
  memcpy(udp_pack, nmr_magic, sizeof(struct nmrhdr));

  /* UDP header + data */
  udp_magic->uh_sport = htons(atoi(gtk_entry_get_text(GTK_ENTRY(src_te))));
  udp_magic->uh_dport = htons(atoi(gtk_entry_get_text(GTK_ENTRY(dst_te))));
  udp_magic->uh_ulen = htons(atoi(gtk_entry_get_text(GTK_ENTRY(ulen_te))) + d_len);
  memcpy(udp_pack + sizeof(struct nmrhdr), udp_magic, sizeof(struct udphdr));
  memcpy(udp_pack + sizeof(struct nmrhdr) + sizeof(struct udphdr), data, d_len);

  /* calculate checksum */
  udp_magic->uh_sum = in_cksum((u_short *)udp_pack, sizeof(struct udphdr) + sizeof(struct nmrhdr) + d_len);
  free(nmr_magic);
  /* make real packet */
  memcpy(udp_pack + sizeof(struct ip), udp_magic, sizeof(struct udphdr));
  memcpy(udp_pack + sizeof(struct ip) + sizeof(struct udphdr), data, d_len);
  udps->d_port = udp_magic->uh_dport;
  free(udp_magic);
  udps->packsz = sizeof(struct ip) + sizeof(struct udphdr) + d_len;

  return udps;
}

/* ICMP subcodes DAMN thats alot */
void icmp_sub(GtkEntry *entry)
{
  GList *subs = NULL;
  char *item;
  static int su = 0;
  item = gtk_entry_get_text(entry);

  if(strstr(item, "Destination Unreachable"))
  {
    if(su){ gtk_widget_hide(isubs); }
    su = 1;
    isubs = make_combo(isubs, 190, 10, 385, 290);
    subs = g_list_append(subs, (void *)"Network Unreachable");
    subs = g_list_append(subs, (void *)"Host Unreachable");
    subs = g_list_append(subs, (void *)"Bad Protocol");
    subs = g_list_append(subs, (void *)"Port Unreachable");
    subs = g_list_append(subs, (void *)"Need Fragmentation");
    subs = g_list_append(subs, (void *)"Source Route Failed");
    subs = g_list_append(subs, (void *)"Unknown Network");
    subs = g_list_append(subs, (void *)"Unknown Host");
    subs = g_list_append(subs, (void *)"Source Host Isolated");
    subs = g_list_append(subs, (void *)"Network Prohibited");
    subs = g_list_append(subs, (void *)"Host Prohibited");
    subs = g_list_append(subs, (void *)"Bad TOS For Network");
    subs = g_list_append(subs, (void *)"Bad TOS For Host");
    subs = g_list_append(subs, (void *)"Packet Filtered");
    subs = g_list_append(subs, (void *)"Host Precedence Violation");
    subs = g_list_append(subs, (void *)"Precedence Cutoff");
    gtk_combo_set_popdown_strings(GTK_COMBO(isubs), subs);
    g_list_free(subs);
    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(isubs)->entry), FALSE);
  }

    else if(strstr(item, "Redirect"))
    {
      if(su){ gtk_widget_hide(isubs); }
      su = 1;
      isubs = make_combo(isubs, 190, 10, 385, 290);
      subs = g_list_append(subs, (void *)"Network Redirect");
      subs = g_list_append(subs, (void *)"Host Redirect");
      subs = g_list_append(subs, (void *)"Network TOS Redirect");
      subs = g_list_append(subs, (void *)"Host TOS Redirect");
      gtk_combo_set_popdown_strings(GTK_COMBO(isubs), subs);
      g_list_free(subs);
      gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(isubs)->entry), FALSE);
    }

      else if(strstr(item, "Time Exceeded"))
      {
        if(su){ gtk_widget_hide(isubs); }
        su = 1;
        isubs = make_combo(isubs, 190, 10, 385, 290);
        subs = g_list_append(subs, (void *)"In Transit");
        subs = g_list_append(subs, (void *)"IP Reassemmbly");
        gtk_combo_set_popdown_strings(GTK_COMBO(isubs), subs);
        g_list_free(subs);
        gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(isubs)->entry), FALSE);
      }

        else if(strstr(item, "Parameter Problem"))
        {
          if(su){ gtk_widget_hide(isubs); }
          su = 1;
          isubs = make_combo(isubs, 190, 10, 385, 290);
          subs = g_list_append(subs, (void *)"Required Option Absent");
          gtk_combo_set_popdown_strings(GTK_COMBO(isubs), subs);
          g_list_free(subs);
          gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(isubs)->entry), FALSE);

        }

          else if(su)
          { gtk_widget_hide(isubs); }
}

/* displaying widgets for ICMP packet */
void icmp_spell(void)
{
  GList *itypes = NULL;
  itype_lbl = icode_lbl = NULL;

  itype_lbl = make_label(itype_lbl, "ICMP Type:", 25, 290);
  itype = make_combo(itype, 170, 10, 102, 290);
  itypes = g_list_append(itypes, (void *)"Echo Reply");
  itypes = g_list_append(itypes, (void *)"Destination Unreachable");
  itypes = g_list_append(itypes, (void *)"Source Quench");
  itypes = g_list_append(itypes, (void *)"Redirect");
  itypes = g_list_append(itypes, (void *)"Echo Request");
  itypes = g_list_append(itypes, (void *)"Router Advertisement");
  itypes = g_list_append(itypes, (void *)"Router Solicitation");
  itypes = g_list_append(itypes, (void *)"Time Exceeded");
  itypes = g_list_append(itypes, (void *)"Parameter Problems");
  itypes = g_list_append(itypes, (void *)"Timestamp Request");
  itypes = g_list_append(itypes, (void *)"Timestamp Reply");
  itypes = g_list_append(itypes, (void *)"Information Request");
  itypes = g_list_append(itypes, (void *)"Information Reply");
  itypes = g_list_append(itypes, (void *)"Address Mask Request");
  itypes = g_list_append(itypes, (void *)"Address Mask Reply");

  gtk_combo_set_popdown_strings(GTK_COMBO(itype), itypes);
  g_list_free(itypes);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(itype)->entry), FALSE);

  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(itype)->entry),
                     "changed",
                     GTK_SIGNAL_FUNC(icmp_sub),
                     GTK_ENTRY(GTK_COMBO(itype)->entry)
                    );

  icode_lbl = make_label(icode_lbl, "ICMP Sub-Code:", 285, 290);
  payload = make_te(payload, 520, 80, 40, 460);
}


void icmp_defaults(void){}

/* clear ICMp widgets */
void clear_icmp(void)
{
  gtk_widget_hide(itype_lbl);
  gtk_widget_hide(itype);
  gtk_widget_hide(icode_lbl);
  if(isubs)
  { gtk_widget_hide(isubs); }
}

/* gather ICMP packet + data info */
struct packmack *icmp_gather(char *icmp_pack)
{
  struct icmp *icmp_magic = clalloc(sizeof(struct icmp));
  struct packmack *icmps = clalloc(sizeof(struct packmack));
  char data[65535 - ( sizeof(struct ip) + sizeof(struct icmp) )];
  int x, d_len = 0;

  memset(data, '\0', sizeof(data));
  if(sizeof(data) > gtk_text_get_length(GTK_TEXT(payload)))
  {
    for(x = 0; x < gtk_text_get_length(GTK_TEXT(payload)); x++)
    { data[x] = GTK_TEXT_INDEX(GTK_TEXT(payload),x); }
    d_len = strlen(data);
  }
  else
  { prterr("Data length to long for one packet!!\n"); }

  icmp_magic->icmp_type = geticmptypebyname(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(itype)->entry)));

  if(isubs == NULL)
  { icmp_magic->icmp_code = 0; }

  else
  { icmp_magic->icmp_code = geticmpsubbyname(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(isubs)->entry))); }

  memcpy(icmp_pack, icmp_magic, sizeof(struct icmp));
  memcpy(icmp_pack + sizeof(struct icmp), data, d_len);
  icmp_magic->icmp_cksum = in_cksum((u_short *)icmp_pack, sizeof(struct icmp) + d_len);
  memcpy(icmp_pack + sizeof(struct ip), icmp_magic, sizeof(struct icmp));
  memcpy(icmp_pack + sizeof(struct ip) + sizeof(struct icmp), data, d_len);
  free(icmp_magic);
  icmps->packsz = sizeof(struct ip) + sizeof(struct icmp) + d_len;
  icmps->d_port = 0;
  return icmps;
}

/* have this so we can return :P , gtk_signal_connect needs a void function! */
void send_packet(GtkWidget *oldbutton)
{   packet_send(); }

int packet_send(void)
{
  int s, yes = 1;
  struct sockaddr_in endup;
  struct in_addr ip_srce, ip_dstn;
  struct protoent *ourproto;
  struct packmack *tcpips = clalloc(sizeof(struct packmack));
  char *envelope = NULL;

  /* get our source and dest addresses */
  ip_srce = wherefromto(gtk_entry_get_text(GTK_ENTRY(sadd_te)));
  if(ip_srce.s_addr == 0) { return -1; }
  ip_dstn = wherefromto(gtk_entry_get_text(GTK_ENTRY(dadd_te)));
  if(ip_dstn.s_addr == 0) { return -1; }
  tcpips->d_port = 0;
  tcpips->packsz = sizeof(struct ip);

  /* get proto */
  if((ourproto = getprotobyname(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(proto)->entry)))) == NULL)
  {
    prterr("Getprotobyname: invalid protocol");
    return -1;
  }

  /* allocate memory for packet and get data */
  if(ourproto->p_proto == 6)
  {
    envelope = clalloc(65535 - (sizeof(struct ip) + sizeof(struct tcphdr)));
    tcpips = tcp_gather(envelope, ip_srce, ip_dstn);
  }
  else if(ourproto->p_proto == 17)
  {
    envelope = clalloc(65535 - (sizeof(struct ip) + sizeof(struct udphdr)));
    tcpips = udp_gather(envelope);
  }
  else if(ourproto->p_proto == 1)
  {
    envelope = clalloc(65535 - (sizeof(struct ip) + sizeof(struct icmp)));
    tcpips = icmp_gather(envelope);
  }
  else if(ourproto->p_proto == 0){ envelope = clalloc(sizeof(struct ip)); }

  gather_info(envelope, ourproto->p_proto, tcpips->packsz);

  /* open a raw socket */
  if((s = socket(PF_INET, SOCK_RAW, IPPROTO_RAW)) == -1)
  {
    perror("socket");
    exit(s);
  }

  /* set socket options at IP level, so we can create our own IP header */
  if((setsockopt(s, SOL_IP, IP_HDRINCL, &yes, sizeof(yes))) == -1)
  {
    prterr("setsockopt");
    exit(-1);
  }

  /* file in sockaddr struct BLAH! */
  memset(&endup, '\0', sizeof(struct sockaddr_in));
  endup.sin_family = PF_INET;
  endup.sin_port = tcpips->d_port;
  endup.sin_addr = ip_dstn;

  /* yes and finally send packet */
  if((sendto(s, envelope, tcpips->packsz, 0, (struct sockaddr *)&endup, sizeof(struct sockaddr))) == -1)
  {
    prterr("sendto: cannot send");
    return -1;
  }

  /* free memory and close socket */
  free(envelope);
  free(tcpips);
  close(s);

  return 0;
}

/* get ip header info from boxes then get ip_magic->protocol header info */
void gather_info(char *envelope, int proto, int pasize)
{
  struct ip *ip_magic = clalloc(sizeof(struct ip));
  char *iteme;

  ip_magic->ip_hl = atoi(gtk_entry_get_text(GTK_ENTRY(hl_te))); /* header length */
  ip_magic->ip_v = atoi(gtk_entry_get_text(GTK_ENTRY(vers_te))); /* version */
  ip_magic->ip_tos = atoi(gtk_entry_get_text(GTK_ENTRY(tos_te))); /* type-of-service */
  ip_magic->ip_len = pasize; /* packet length */

  ip_magic->ip_id = atoi(gtk_entry_get_text(GTK_ENTRY(id_te))); /* ID */
 /* ip_magic->ip_off = atoi(gtk_entry_get_text(GTK_ENTRY(fragoff_te))); */
  ip_magic->ip_ttl = atoi(gtk_entry_get_text(GTK_ENTRY(ttl_te))); /* time to live */
  ip_magic->ip_p = proto; /* protocol */

  /* fragmentation */
  iteme = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(frag)->entry));
  if(strstr(iteme, "Fragment") && !strstr(iteme, "Don't") && !strstr(iteme, "More"))
  {  ip_magic->ip_off = 16; }
  else if(strstr(iteme, "Don't"))
  { ip_magic->ip_off = 64; }
  else if (strstr(iteme, "More"))
  { ip_magic->ip_off = 32; }
  else if(strstr(iteme, "None"))
  { ip_magic->ip_off = 0; }


  ip_magic->ip_src = wherefromto(gtk_entry_get_text(GTK_ENTRY(sadd_te))); /* source address */
  ip_magic->ip_dst = wherefromto(gtk_entry_get_text(GTK_ENTRY(dadd_te))); /* destination address */
  memcpy(envelope, ip_magic, sizeof(struct ip)); /* copy IP header to packet */

}




