/***************************************************************************
                          spells.c  -  more spells
                             -------------------
    begin                : Sat Sep 22 2001
    copyright            : (C) 2001 by Josiah Zayner
    email                : ajz023@motorola.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "ingredients.h"

struct in_addr wherefromto(char *herefrom)
{
  struct in_addr addr;
  struct hostent *host;

  memset(&addr, '\0', sizeof(struct in_addr));

  if((host = gethostbyname(herefrom)) == NULL)
  {
     if(inet_aton(herefrom, &addr) == 0)
     { prterr("Cannot Resolve Host, please specify IP!"); }

  }
  else { memcpy(&addr, host->h_addr_list[0], sizeof(struct in_addr)); }

  return addr;
}



/* standard Internet Protocol checksum*/
u_short in_cksum(u_short *addr, int len)
{
	register u_short answer;
	register u_int sum = 0;
	u_short oddbyte = 0;

	/*
	 * Our algorithm is simple, using a 32 bit accumulator (sum), we add
	 * sequential 16 bit words to it, and at the end, fold back all the
	 * carry bits from the top 16 bits into the lower 16 bits.
	 */

	while (len > 1)  {
		sum += *addr++;
		len -= 2;
	}

	/* mop up an odd byte, if necessary */
	if (len == 1) {
		*((u_char *)&oddbyte) = *(u_char *)addr ;
		sum += oddbyte;
	}

	/* add back carry outs from top 16 bits to low 16 bits */
	sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
	sum += (sum >> 16);			/* add carry */
	answer = ~sum;				/* truncate to 16 bits */
	return(answer);
}


/* clear and allocate memory */
void *clalloc(int bytes)
{
  void *ret;
  if((ret = malloc(bytes)) == NULL)
  {
    prterr("Cannot allocate memory!");
    exit(-1);
  }
  memset(ret,'\0', bytes);

  return ret;
}

